// -*-c++-*-

/*!
  \file bhv_mark_player.h
  \brief do 1-on-1 defense
*/

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BHV_MARK_PLAYER_H
#define BHV_MARK_PLAYER_H

#include <rcsc/player/soccer_action.h>

namespace rcsc
{
    class AbstractPlayerObject;
}

/*!
  \class Bhv_MarkPlayer
  \brief do 1-on-1 defense
*/
class Bhv_MarkPlayer
    : public rcsc::SoccerBehavior {

    const rcsc::AbstractPlayerObject * M_target;

public:
    /*!
      \brief constructor
     */
    Bhv_MarkPlayer( const rcsc::AbstractPlayerObject * target );

    /*!
      \brief do mark
      \param agent agent pointer to the agent itself
      \return true with action, false if nothong to do
     */
    bool execute( rcsc::PlayerAgent * agent );
};

#endif
