// -*-c++-*-

/*!
  \file bhv_receive_pass.h
  \brief run to ball with checking information of players for next pass.
*/

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BHV_RECEIVE_PASS_H
#define BHV_RECEIVE_PASS_H

#include <rcsc/player/soccer_action.h>

/*!
  \class Bhv_ReceivePass
  \brief run to ball with checking information of players for next pass.
*/
class Bhv_ReceivePass
    : public rcsc::SoccerBehavior {

public:
    /*!
      \brief constructor
     */
    Bhv_ReceivePass();

    /*!
      \brief run to ball with checking information of players for next pass.
      \param agent agent pointer to the agent itself
      \return true with action, false if no need to do.
     */
    bool execute( rcsc::PlayerAgent * agent );
};

#endif
