// -*-c++-*-

/*!
  \file body_go_to_forward_free_space.h
  \brief go to free point near opponent's offside line
*/

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BODY_CLEAR_BALL_2008_H
#define BODY_CLEAR_BALL_2008_H

#include <rcsc/player/soccer_action.h>

namespace rcsc
{
    class WorldModel;
}

/*!
  \class Body_ClearBall2008
  \brief go to free point near opponent's offside line
*/
class Body_GoToForwardFreeSpace
    : public rcsc::BodyAction {

private:
    double M_y_min;
    double M_y_max;
    double M_dash_power;

protected:
    double getPositionX( const rcsc::WorldModel & wm ) const;

public:
    /*!
      \brief constructor
     */
    Body_GoToForwardFreeSpace( double y_min, double y_max,
                               double dash_power );

    /*!
      \brief do clear ball
      \param agent agent pointer to the agent itself
      \return true with action, false if can't do action
     */
    bool execute( rcsc::PlayerAgent * agent );
};

#endif
